<?php
// Image Parser Inpired from http://redsunsoft.com/tag/regex/   tony@redsunsoft.com 

$FBUsername = get_option('fbap_fbUsername');
$FBUDefined = FALSE ; 
if(!empty($FBUsername)) $FBUDefined = TRUE ; 
$ajax_nonce = wp_create_nonce( "fbap_nonce" );
?>

<html>
<head>
</head>
<body>
	<h2> <?php _e('Create Post from a Facebook Album'); ?> </h2>
	<form action="" method="post" enctype="multipart/form-data">
		<div>
		<table id="fap" >
			<tr>
				<td colspan="2"><p>The post that will be created will contain: <ul><li>A Title</li><li>A Featured Image from the Facebook Album (hosted on your Wordpress)</li><li>The Facebook Page Photo Gallery shortcode</li></ul></p> <p>The created post will be saved in <strong>Draft Mode</strong> to let you edit it before plublishing.</p></td>
			</tr>
			<tr>
				<td Colspan="2"><?php echo $status ;unset($status);	?></td>
			</tr>
			<?php if($FBUDefined) { ?>
			<tr>
				<td><span id="labelFBUsername"><?php echo $FBUsername.'\'s albums' ?></span></td>
				<td><div id='userAlbums' style="display:none;"><select id="userAlbumsSelect"></select></div></td></tr>
			<tr>
			<?php } ?>
			<tr>
				<td><span id="labelAU"><?php _e('Paste Album URL here'); ?></span></td>
				<td><input id="url" type="text" name="facebook_album_url" /></td>			</tr>
			<tr>
				<td><?php _e('Post Title'); ?></td>
				<td><input id="title" type="text" name="title"  /></td>
			</tr>
			<tr>
				<td Colspan="2"><button id="fap_load" type="button" class="button button-primary button-large" name="submit" value="Create Facebook Album Post"> Load Facebook Album</button> <button id="fap_submit" type="button" class="button button-primary button-large" style="display:none" name="submit" value="Create Facebook Album Post"> Create Facebook Album Post</button></td>
			</tr>
		</table>
		
		
		<div id="atc_loader">
	
			<div align="center" id="atc_loading" style="display:none"><img src="<?php echo plugins_url(); ?>/facebook-album-post/images/load.gif" alt="Loading" /></div>
			<div id="attach_content" style="display:none">
				
				<div id="atc_total_image_box">
					<h2>Select your Featured Image</h2>

					<div id="atc_images"></div>
					<div id="atc_total_image_nav" > 
						<div id="prev"><img src="<?php echo plugins_url(); ?>/facebook-album-post/images/prev.png"  alt="Prev" border="0" /></div><div id="next"><img src="<?php echo plugins_url(); ?>/facebook-album-post/images/next.png" alt="Next" border="0" /></div>
					</div>
				 
					<div id="atc_total_images_info" >
						Image <span id="cur_image_num">1</span> of <span id="atc_total_images">1</span>
					</div>
				</div>
				
				
				<div id="atc_info">
				 
					<label id="atc_title"></label>
					<label id="atc_url"></label>
					<br clear="all" />
					<label id="atc_desc"></label>
					<br clear="all" />
				</div>
				
				<br clear="all" />
			</div>
		</div>
		
		

		
	</form>
	
<script>

	jQuery(document).ready(function($){	
 		
 		//Setup Ajax Script URL
 		var url = '<?php echo plugins_url(); ?>/facebook-album-post/ajax.php';
 		
 		var fbUsernameDefined = <?php if($FBUDefined){ echo 'true' ;  }else echo 'false' ; ?>; 
 		//Preload User Facebook Albums Names in a Dropdownlist
 		if (fbUsernameDefined) {
 			var fb_username= '<?php echo $FBUsername ; ?>';

			$.post(ajaxurl, 
			 	{
			       username:fb_username,
			       security: '<?php echo $ajax_nonce; ?>',
			       action:'getUserPublicAlbumsAjax'
			 	}, 
			    function(response){
					var select= '<option value="0">Select an album</option>';
	           		var option = '';
	            	$.each(response.data, function(index, value) {
	                option += '<option value="'+value.id+'">' + value.name + '</option>';
	            	});
	           		select = select+option;
					$( "#userAlbumsSelect" ).html( select );
			     });
			
			$('#userAlbums').show() ;
			
			//add Binding
			$('#userAlbumsSelect').bind("change", parseAlbum);
 		}

 		
		
		// Add bindings
		$('#fap_submit').bind("click", addItem);
		$('#fap_load').bind("click", parse_link);
		
		$('#url').on('paste', function () {
		  var element = this;
		  setTimeout(function () {
		    var text = $(element).val();
		    parse_link() ; 
		  }, 100);
		});
		
		// When a link 		
		function parse_link (shortprocess)
		{
			shortprocess = typeof shortprocess !== 'undefined' ? shortprocess : false;
			if(!isValidURL($('#url').val()) && shortprocess==false)
			{
				alert('Please enter a valid url.');
				return false;
			}
			else
			{
				//Extract Album Id
				if(shortprocess){fb_id = $('#userAlbumsSelect').val() ; }
				else{
					fbVars= $('#url').val().split('?set=');
					tmp = fbVars[1].split('.') ;
					fb_id = tmp[1] ;
				}
				//While Ajax Request is processing, show the loading animation
				$('#atc_loading').show();
				
				$.post(ajaxurl, 
			 		{
			       		facebook_album_id:fb_id,
			       		security: '<?php echo $ajax_nonce; ?>',
			      		facebook_album_url:encodeURI($('#url').val()),
			       		action:'getAlbumAjax'
			 		},					
					
					function(response){
					
					//Set Content
					$('#title').val(response.name);
					$('#atc_images').html(' ');
					$('#atc_total_images').html(response.photos.data.length);
					
					//Browse JSON Response to get photos URLs and add images
					$.each(response.photos.data, function (a, b)
					{
						$('#atc_images').append('<img src="'+b.images[0].source+'" width="100%" id="'+(a+1)+'">');
					});
					$('#atc_images img').hide();
					
					//Flip Viewable Content 
					$('#attach_content').fadeIn('slow');
					$('#atc_loading').hide();
					$('#fap_submit').show() ;
					$('#fap_load').hide() ;
					
					
					//Show first image
					$('img#1').fadeIn();
					$('#cur_image').val(1);
					$('#cur_image_num').html(1);
					
					// next image
					$('#next').unbind('click');
					$('#next').bind("click", function(){
					 
						var total_images = parseInt($('#atc_total_images').html());
						if (total_images > 0)
						{
							var index = parseInt($('#cur_image_num').html());
							$('img#'+index).hide();
							if(index < total_images)
							{
								new_index = parseInt(index)+parseInt(1);
							}
							else
							{
								new_index = 1;
							}
							
							$('#cur_image').val(new_index);
							$('#cur_image_num').html(new_index);
							$('img#'+new_index).show();
						}
					});	
					
					// prev image
					$('#prev').unbind('click');
					$('#prev').bind("click", function(){
					 
						var total_images = parseInt($('#atc_total_images').html());				 
						if (total_images > 0)
						{
							var index = parseInt($('#cur_image_num').html());
							$('img#'+index).hide();
							if(index > 1)
							{
								new_index = parseInt(index)-parseInt(1);;
							}
							else
							{
								new_index = total_images;
							}
							
							$('#cur_image').val(new_index);
							$('#cur_image_num').html(new_index);
							$('img#'+new_index).show();
					 	}
					});	
				});
			}
		};	
		

		function addItem(event){
			$('#fap_submit').hide() ;

			//Get current image index
			var index = parseInt($('#cur_image_num').html());
			
			//Ajax request to add post
			$.post(ajaxurl, 
			 	{
			       HWAPPID:"test",
			       facebook_album_id:fb_id,
			       title:$('#title').val() ,  
			       imageUrl:$('img#'+index).attr('src'), 
			       security: '<?php echo $ajax_nonce; ?>',
			       action:'properAddItemAjax'
			 	}, 
			    function(response){
					alert('Your facebook album post '+ $('#title').val() +' has been created !');
					$('#fap_load').show() ;
			     });
		}
		
		function parseAlbum(){
			if($('#userAlbumsSelect').val() != '0'){
				//$('#url').val($('#userAlbumsSelect').val()) ; 
				$('#url').val('') ; 
				parse_link(true) ; 
			}
		}
		
		
	});
	
	



	//Check URL pattern
	function isValidURL(url)
	{
		var RegExp = /(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/;
		
		if(RegExp.test(url)){
			return true;
		}else{
			return false;
		}
	}
</script>			
</body>
</html>

